unit DSForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    LBFiles: TListBox;
    Label1: TLabel;
    procedure LBFilesMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure LBFilesMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure LBFilesMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormCreate(Sender: TObject);
  private
    DragPoint:TPoint;
    FDragStarted:boolean;
    procedure GetDataNotify(const DataList:TStringList;IsFirstTime:boolean);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
uses DataObj,ComObj,ActiveX;

{$R *.dfm}

procedure TForm1.LBFilesMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     if mbLeft=Button  then 
      begin
        DragPoint.X:=X;
        DragPoint.Y:=Y;
      end
end;

procedure TForm1.LBFilesMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     if Button=mbLeft then 
     begin
       DragPoint.X:=$FFFFFFFF;
       DragPoint.Y:=$FFFFFFFF;
     end;
end;

procedure TForm1.LBFilesMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var FileSource:TFileSource;
    DataObject:TDataObject;
    DP:TPoint;
    dwEffect:LongInt;
    FileList:TStringList;
    i:integer;
    CD,S:string;
begin
     if FDragStarted then Exit;
     if (ssLeft in Shift) and 
        (DragPoint.X<>$FFFFFFFF) and
        (DragPoint.Y<>$FFFFFFFF) then 
      if (abs(X-DragPoint.X)+abs(Y-DragPoint.Y))>10 then 
      begin
         FDragStarted:=True;
         DragPoint.X:=$FFFFFFFF;
         DragPoint.Y:=$FFFFFFFF;
         FileList:=nil;
         try
           FileList:=TStringList.Create;
           GetDir(0,CD);
           for i:=0 to LBFiles.Items.Count-1 do
            if LBFiles.Selected[i] then 
            begin
              S:=CD+'\'+LBFiles.Items[i];
              FileList.Add(S);
            end;
            if FileList.Count>0 then 
            begin
              FileSource:=TFileSource.Create;
              DP.X:=100;
              DP.Y:=100;
              DataObject:=TDataObject.Create(FileList,GetDataNotify,DP,True);
              OleCheck(DoDragDrop(DataObject as IDataObject,
                  FileSource as IDropSource,
                  DROPEFFECT_COPY,
                  dwEffect));
            end;
         finally
            FileList.Free;
            {It is not necessary to destroy IDataObject and    }
            {IDropSource - they will be destroyed automatically}
            FDragStarted:=False;
         end;
      end;
end;

procedure TForm1.GetDataNotify(const DataList:TStringList;IsFirstTime:boolean);
var F:TextFile;
    i:integer;
begin
     if not IsFirstTime then Exit;
     if Assigned(DataList) and (DataList.Count>0) then 
       for i:=0 to DataList.Count-1 do
       begin
         AssignFile(F,DataList[i]);
         Rewrite(F);
         Writeln(F,ExtractFileName(DataList[i]));
         CloseFile(F);
       end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var CD,S:string;
    i:integer;
begin
     GetDir(0,CD);
     for i:=0 to LBFiles.Items.Count-1 do
         if LBFiles.Selected[i] then 
         begin
           S:=CD+'\'+LBFiles.Items[i];
           DeleteFile(S);
         end;
end;

end.
